function [flag, vertexList] = VRepWeighted(outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
    emodels, vpointList, grid_xy, grid_coord, max_deg,a)
% clear all;
% [outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
%     vmodels,emodels, vpointList, grid_xy, grid_coord, max_deg,a] = initialize;
figure;
gplot(targetGrid, grid_coord, 'y');
% firstPath = zeros(1,length(grid_coord));
hold on
plot(vertexList(1).position(1), vertexList(1).position(2), '*')
flag = true;
%Connecting vertices to their bottom neighbors, based on the labels.
i =2;
while (i<=length(vertexList)) && flag
    if i == 15
        true;
    end
    fprintf('iteration = %d\n',i);
    vIndex = vertexList(i).vIndex;
    vCanIndex = i;
    hold on
    plot(vertexList(i).position(1), vertexList(i).position(2), '*')
    hold on;
    gplot(outputGrid,grid_coord,'r');
    hold on
    gplot(targetGrid, grid_coord, 'c');
%     criticalP = [vpointList(i)-1, vpointList(i)-a, vpointList(i)-1-a];
    j=1;
    while (j<=size(vertexList(i).lowNeiList,1)) && (flag)
            
            wIndex = vertexList(i).lowNeiList(j);
            wCanIndex = verToCanMap(wIndex);
            % change -1 to +1 ???!!!!
            % all edges come out from left
            p1 = posToPoint(vertexList(i).position(1) - 1, vertexList(i).position(2), a);
            [pointPermit, vertexList] = editLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            p2 = posToPoint(vertexList(wCanIndex).position(1) - 1, vertexList(wCanIndex).position(2), a);
            [pointPermit, vertexList] = editLabel(p2, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            % here +1
            p1 = posToPoint(vertexList(i).position(1)+1, vertexList(i).position(2), a);
            [pointPermit, vertexList] = editLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            p2 = posToPoint(vertexList(wCanIndex).position(1)+ 1, vertexList(wCanIndex).position(2), a);
            [pointPermit, vertexList] = editLabel(p2, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            
            %Now the algorithm dictates that we make the available points 
            %of each of the two vertices available in the targetGrid. Then
            %for now, we decide to make the available points of all other            
            %vertices unavailable. This is not an efficient approach, but
            %in the final implementation A* can be modified in a way that            
            %only finds a path through vertices with certain labels.
           
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
%                 gplot(targetGrid,grid_coord,'g');
            end
%             targetGrid = makeAvailableList(vertexList(vCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
%                 gplot(targetGrid,grid_coord,'g');
            end
%             targetGrid = makeAvailableList(vertexList(wCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList)
                if k ~= vCanIndex && k ~= wCanIndex
                    for kk = 1:length(vertexList(k).avaiPointList)
                        if pointPermit(vertexList(k).avaiPointList(kk),vIndex) == 0 && ...
                                pointPermit(vertexList(k).avaiPointList(kk),wIndex) == 0
                            targetGrid = makeUnavailable(vertexList(k).avaiPointList(kk), targetGrid, a);
                        end
                    end
                  
                end
            end
            targetGrid = makeUnavailableList(vertexList, targetGrid, a, vCanIndex, wCanIndex);
            %Now we need to find the shortest path between v(the vertex
            %being processed) and w(the neighbor), using A-Star
            start = posToPoint(vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2), a);
%             setAstarStart(vertexList, a, vCanIndex,targetGrid);
            % set the goal to be the neighbor itself or a vertex in its
            % available points####JAN 25
            goal = posToPoint(vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2), a);
%             setAstarGoal(vertexList, a, wCanIndex,targetGrid);
            weightedGrid = create_weightedGraph(emodels{i,1}, emodels{wCanIndex,1},targetGrid);
            % Use the manhattan distance to the goal as the heuristic
            h = @(u) abs(grid_xy(u,1) - grid_xy(goal,1))+ abs(grid_xy(u,2) - grid_xy(goal,2));
%              h = @(u) norm(grid_xy(u,:) - grid_xy(goal,:));
            % Setup a routine to stop when we find the goal
            ev = @(u) (u ~= goal);
            
            if length(targetGrid)>10e4
                % create a temporary box for A-star
                v = [vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2)];
                w = [vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2)];
                targetGrid = boxForAstar(targetGrid,grid_coord, a,start,goal,v,w);
                [~, pred, ~] = astar_search(targetGrid, start, h, struct('edge_weight',weights,'visitor', struct('examine_vertex', ev)));
            else
                [~, pred, ~] = astar_search(weightedGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
                [~, pred2, ~] = astar_search(targetGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
            end
            fprintf('diff = %d\n',sum(pred-pred2));
%             if (size(vertexList(i).lowNeiList,1)>1) 
%                 if (j==1)   
%                     firstPath = pred;   
%                 elseif (j>1) && ~isempty(find(vertexList(i).avaiPointList==criticalP(1), 1)) ...
%                     && ~isempty(find(vertexList(i).avaiPointList==criticalP(2), 1))...
%                     && ~isempty(find(vertexList(i).avaiPointList==criticalP(3),1))
%                     pred(vpointList(i)-1-a: vpointList(i)-a) = firstPath(vpointList(i)-1-a: vpointList(i)-a);
%                 end
%             end
            etempv = [];
            etempw = [];
            g = goal;
            while (true)
                gb = pred(g);
                if isequal(gb,0)
                    flag = false;
                    break;
                end
                outputGrid = addEdge(outputGrid, g, gb);
                if gb == start
                    break
                end
                [pointPermit, vertexList,removedFromV,addTo] = editLabel(gb, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
                etempv(end+1,:) = [g,gb];
                etempw(end+1,:) = [g,gb];
                if ~isequal(removedFromV,0)
                    if addTo == vIndex
                      [etempw, emodels] = fixEmodels(gb,etempw,emodels,removedFromV, verToCanMap);
                    else
                      [etempv, emodels] = fixEmodels(gb,etempv,emodels,removedFromV, verToCanMap);  
                    end
                end
                g = gb;
            end
            emodels{i,1} = etempv;
            emodels{wCanIndex,1} = etempw;
%             vmodels{i,1} = create_vmodels(vmodels{i,1}, pred, pointPermit,start, goal,vIndex);
            %Now it is time to make the available points of both v and w,
            %unavailable.
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
            end
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
            end
            j = j+1;
    end
%     firstPath =0;
%     p1 = posToPoint(vertexList(i).position(1)+1, vertexList(i).position(2), a);
%     if isempty(find(vertexList(i).avaiPointList == (p1+1),1))
%         [pointPermit, vertexList] = removeLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
%     end
    i = i+1;
end
% 
% plot(vertexList(i).position(1), vertexList(i).position(2), '*')
    hold on;
    gplot(outputGrid,grid_coord,'r');
    hold on
    gplot(targetGrid, grid_coord, 'c');



