function grid = boxForAstar(grid,coord,a,start,goal,v,w)

stCorner = start+a+1; % one row up, one col right
if(goal-a-2 >0)
    gCorner = goal-a-2;  % one row down, two col left
else
    gCorner = goal-2;
end
vx = v(1); vy = v(2);
wx = w(1); wy= w(2);
Dx = abs(wx-vx);
Dy = abs(vy-wy);
upCorner = Dy*a+gCorner+1;
downCorner = stCorner-a*Dy-1;

% upper row
for k = 1:length(upCorner:1:stCorner)
    p = upCorner+(k-1);
    c = coord(p,:);
    %targetGrid = makeUnavailable(p, targetGrid, a);
    grid = removeEdge(grid, p, p + a);
    
end
% lower row
for k = 1:length(gCorner:1:downCorner)
    p = gCorner+(k-1);
    %targetGrid = makeUnavailable(p, targetGrid, a);
    if p-a >0 
        grid = removeEdge(grid, p, p - a);
    end
end
% left col
for k = 1:length(gCorner:1:upCorner)
    p = upCorner+a*(k-1);
    %targetGrid = makeUnavailable(p, targetGrid, a);
    if p-1>0
        grid = removeEdge(grid, p, p - 1);
    end

end
% right col
for k = 1:length(downCorner:1:stCorner)
    p = upCorner+a*(k-1);
    grid = removeEdge(grid, p, p + 1);
end






end