function [pointPermit, vertexList, removedFromV, addTo] = editLabel(p, v1, v2, pointPermit, vertexList, verToCanMap )
%This is function for which the proof of correctness is availbale only
%through considering the transitive states of the algorithm. The function
%gets as input, a point in the grid, and two vertices that are to be
%connected at this point of the algorithm, and the path between them is
%going to cross this point.
removedFromV = 0; addTo = 0;
tempAns = find(pointPermit(p,:));
if length(tempAns) == 1
    %The point is permanently owned. No changes shall be made.
elseif isempty(tempAns)
    pointPermit(p, v1) = 1;
    pointPermit(p, v2) = 1;
    vLIndex1 = verToCanMap(v1);
    vLIndex2 = verToCanMap(v2);
    vertexList(vLIndex1).avaiPointList(end + 1) = p;
    vertexList(vLIndex1).avaiPointList = unique(vertexList(vLIndex1).avaiPointList);
    vertexList(vLIndex2).avaiPointList(end + 1) = p;
    vertexList(vLIndex2).avaiPointList = unique(vertexList(vLIndex2).avaiPointList);
elseif length(tempAns) == 2
    tempInp = [v1 v2];
    inter = intersect(tempInp, tempAns);
    if length(inter) == 2
        %Redundant Case
    elseif length(inter) == 1
        if tempAns(1) == inter
            pointPermit(p, tempAns(2)) = 0;
            tempList = vertexList(verToCanMap(tempAns(2))).avaiPointList;
            vertexList(verToCanMap(tempAns(2))).avaiPointList = tempList(tempList ~= p);
            removedFromV = tempAns(2);
            addTo = tempAns(1);
        else
            pointPermit(p, tempAns(1)) = 0;
            tempList = vertexList(verToCanMap(tempAns(1))).avaiPointList;
            vertexList(verToCanMap(tempAns(1))).avaiPointList = tempList(tempList ~= p);
            removedFromV = tempAns(1);
            addTo = tempAns(2);
        end
    end
end


end

