
w = ones(nnz(B),1);
for j=1:length(vertexList(i).avaiPointList)
    t1 = vertexList(i).avaiPointList(j);
    if j==1
        t2 = posToPoint(vertexList(i).position(1),vertexList(i).position(2),a);
    else
        t2 = vertexList(i).avaiPointList(j-1);
    end
    counts = 0;
    countb = 0;
    if t1<t2
        barrier = t2;
        flag = false;
    else
        barrier = t1;
        flag = true;
    end
    for k=1:barrier
        temp = find(B(:,k)~=0);
        countb = countb+temp;
        if flag
            if k==t1-1
                counts = countb;
            end
        else
            if k==t2-1
                counts = countb;
            end
        end
    end
    in1 = find(B(:,t2)~=0);
    ind1 = find(in1==t1);
    in2 = find(B(:,t1)~=0);
    ind2 = find(in2==t2);
    if flag 
        w(counts+ind2) = 1/1e3;
    else
        w(counts+ind1) = 1/1e3;
    end
end
%% 
%% 
%% 
%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function weigrid = create_weightedGraph(vertex, wvertex, edgesv, edgesw,grid,a)

weigrid = grid;
v = posToPoint(vertex.position(1),vertex.position(2),a);
vw = posToPoint(wvertex.position(1),wvertex.position(2),a);

edgelist = [];
j=1; t2=0;
while j<=length(vertex.avaiPointList)
    t1 = vertex.avaiPointList(j);
    if abs(v-t1)==1
        t2 = v;
        j = j+1;
    elseif j>1 && abs(vertex.avaiPointList(j-1)-t1)==1 && ...
            ~isempty(find(edgesv,[t1,vertex.avaiPointList(j-1)]))
        t2 = vertex.avaiPointList(j-1);
        j = j+1;
    elseif j<length(vertex.avaiPointList) && abs(vertex.avaiPointList(j+1)-t1)==1 && ...
            edgesv(t1,vertex.avaiPointList(j+1))
        t2 = vertex.avaiPointList(j+1);
        j = j+1;
    elseif j>1 && mod(abs(t1-v),a)==0 
        t2 = v;
        j = j+1;
    elseif j>1 && mod(abs(vertex.avaiPointList(j-1)-t1),a)==0 && ...
            edgesv(t1,vertex.avaiPointList(j-1))
        t2 = vertex.avaiPointList(j-1);
        j = j+1;
    elseif j<length(vertex.avaiPointList) && mod(abs(vertex.avaiPointList(j+1)-t1),a)==0 && ...
            edgesv(t1,vertex.avaiPointList(j+1))
        t2 = vertex.avaiPointList(j+1);
        j = j+1;
    else
        j = j+1;
    end
    if t2~=0;  edgelist(end+1,:) = [t1,t2]; end
%     if j<length(vertex.avaiPointList);  end
%     j = j+1;
    t2 = 0;
end


for j=1:size(edgelist,1)
    t1 = edgelist(j,1);
    t2 = edgelist(j,2);
    if grid(t1,t2) ~=0 
        weigrid(t1,t2) = 1/1e7;
        weigrid(t2,t1) = 1/1e7;   
    end
end



% for neighbor
edgelist = [];
j=1; t2=0;
while j<=length(wvertex.avaiPointList)
    t1 = wvertex.avaiPointList(j);
    if abs(vw-t1)==1
        t2 = vw;
        j = j+1;
    elseif j>1 && abs(wvertex.avaiPointList(j-1)-t1)==1 && ...
            edgesw(t1,wvertex.avaiPointList(j-1))
        t2 = wvertex.avaiPointList(j-1);
        j = j+1;
        
    elseif j<length(wvertex.avaiPointList) && abs(wvertex.avaiPointList(j+1)-t1)==1 ...
            && edgesw(t1,wvertex.avaiPointList(j+1))
        t2 = wvertex.avaiPointList(j+1);
        j = j+1;
    elseif j>1 && mod(abs(t1-vw),a)==0 
        t2 = vw;
        j = j+1;
    elseif j>1 && mod(abs(wvertex.avaiPointList(j-1)-t1),a)==0 && ...
            edgesw(t1,wvertex.avaiPointList(j-1))
        t2 = wvertex.avaiPointList(j-1);
        j = j+1;
    elseif j<length(wvertex.avaiPointList) && mod(abs(wvertex.avaiPointList(j+1)-t1),a)==0 && ...
            edgesw(t1,wvertex.avaiPointList(j+1))
        t2 = wvertex.avaiPointList(j+1);
        j = j+1;
    else
        j = j+1;
    end
    if t2~=0;  edgelist(end+1,:) = [t1,t2]; end
%     if j<length(vertex.avaiPointList);  end
%     j = j+1;
    t2=0;
end

for j=1:size(edgelist,1)
    t1 = edgelist(j,1);
    t2 = edgelist(j,2);
    if grid(t1,t2) ~= 0
        weigrid(t1,t2) = 1/1e7;
        weigrid(t2,t1) = 1/1e7; 
    end
end


end






