function w = create_weightsMat(vertex,wvertex,grid,a)

w = ones(nnz(grid),1);
v = posToPoint(vertex.position(1),vertex.position(2),a);
vw = posToPoint(wvertex.position(1),wvertex.position(2),a);

edgelist = [];
j=1; t2=0;
while j<=length(vertex.avaiPointList)
    t1 = vertex.avaiPointList(j);
    if abs(v-t1)==1
        t2 = v;
        j = j+1;
    elseif j>1 && abs(vertex.avaiPointList(j-1)-t1)==1
        t2 = vertex.avaiPointList(j-1);
        j = j+1;
    elseif j<length(vertex.avaiPointList) && abs(vertex.avaiPointList(j+1)-t1)==1
        t2 = vertex.avaiPointList(j+1);
        j = j+1;
    elseif j>1 && mod(abs(t1-v),a)==0 
        t2 = v;
        j = j+1;
    elseif j>1 && mod(abs(vertex.avaiPointList(j-1)-t1),a)==0
        t2 = vertex.avaiPointList(j-1);
        j = j+1;
    else
        j = j+1;
    end
    if t2~=0;  edgelist(end+1,:) = [t1,t2]; end
%     if j<length(vertex.avaiPointList);  end
%     j = j+1;
    t2 = 0;
end


for j=1:size(edgelist,1)
    t1 = edgelist(j,1);
    t2 = edgelist(j,2);
    counts = 0;
    countb = 0;
    if t1<t2
        barrier = t2;
        flag = false;
    else % t2 smaller
        barrier = t1;
        flag = true;
    end
    for k=1:barrier-1
        temp = length(find(grid(:,k)~=0));
        countb = countb+temp;
        if flag
            if k==t2-1
                counts = countb;
            end
        else
            if k==t1-1
                counts = countb;
            end
        end
    end
    in1 = find(grid(:,t2)~=0);
    ind1 = find(in1==t1);
    in2 = find(grid(:,t1)~=0);
    ind2 = find(in2==t2);
    if flag 
        w(counts+ind1) = 1/1e3;
        w(countb+ind2) = 1/1e3;
    else
        w(counts+ind2) = 1/1e3;
        w(countb+ind1) = 1/1e3;
    end
end

% for neighbor
edgelist = [];
j=1; t2=0;
while j<=length(wvertex.avaiPointList)
    t1 = wvertex.avaiPointList(j);
    if abs(vw-t1)==1
        t2 = vw;
        j = j+1;
    elseif j>1 && abs(wvertex.avaiPointList(j-1)-t1)==1
        t2 = wvertex.avaiPointList(j-1);
        j = j+1;
        
    elseif j<length(wvertex.avaiPointList) && abs(wvertex.avaiPointList(j+1)-t1)==1
        t2 = wvertex.avaiPointList(j+1);
        j = j+1;
    elseif j>1 && mod(abs(t1-vw),a)==0 
        t2 = vw;
        j = j+1;
    elseif j>1 && mod(abs(wvertex.avaiPointList(j-1)-t1),a)==0
        t2 = wvertex.avaiPointList(j-1);
        j = j+1;
    else
        j = j+1;
    end
    if t2~=0;  edgelist(end+1,:) = [t1,t2]; end
%     if j<length(vertex.avaiPointList);  end
%     j = j+1;
    t2=0;
end

for j=1:size(edgelist,1)
    t1 = edgelist(j,1);
    t2 = edgelist(j,2);
    counts = 0;
    countb = 0;
    if t1<t2
        barrier = t2;
        flag = false;
    else % t2 smaller
        barrier = t1;
        flag = true;
    end
    for k=1:barrier-1
        temp = length(find(grid(:,k)~=0));
        countb = countb+temp;
        if flag
            if k==t2-1
                counts = countb;
            end
        else
            if k==t1-1
                counts = countb;
            end
        end
    end
    in1 = find(grid(:,t2)~=0);
    ind1 = find(in1==t1);
    in2 = find(grid(:,t1)~=0);
    ind2 = find(in2==t2);
    if flag 
        w(counts+ind1) = 1/1e3;
        w(countb+ind2) = 1/1e3;
    else
        w(counts+ind2) = 1/1e3;
        w(countb+ind1) = 1/1e3;
    end
end





end





