function [inputOrder, vertexNum, A] = getEdgeOrder(str)
    
    maxDegree = 55;
    maxDegree = maxDegree + 1;
    fid = fopen(str,'r');
    cc = fread(fid,'*char');
    ch = cc';
    ch(strfind(ch, '=')) = [];
    nIndex = strfind(ch,':');
    n = min(nIndex)-1;
    ch(strfind(ch, ':')) = [];
    delimit = strfind(ch,'-1');
    % vertices
    vertexNum = length(delimit);
    %sscanf(ch(2:n), '%d', 1);
    adjacencyList = cell(vertexNum,1);
    edgeNum = 0;
    for i = 1:length(delimit)
        if i == 1
            Value = sscanf(ch(n:delimit(i)), '%d', maxDegree);
        elseif i == length(delimit)
            Value = sscanf(ch(delimit(i-1)+2:delimit(end)), '%d', maxDegree);
        else
            Value = sscanf(ch(delimit(i-1)+2:delimit(i)), '%d', maxDegree);
        end
        edgeNum = edgeNum + length(Value');
        adjacencyList{i,1} = Value'+1;
    end
    t = 0;
    inputOrder = zeros(edgeNum,2);
    for j = 1:vertexNum
        for k = 1:length(adjacencyList{j,1})
            inputOrder(t+k,1) = adjacencyList{j,1}(1,k);
            inputOrder(t+k,2) = j;
        end
        t = t+length(adjacencyList{j,1});
    end
    
    fclose(fid);
    
    A = getAdjMat(adjacencyList, vertexNum);
end