function targetGrid = makeAvailableList(list, targetGrid, a, pointList)
%Makes a point available in the targetGrid
track = zeros(length(pointList),1);
for i=1:length(list)
    p = list(i);
    temp = find(pointList == (p+1),1);
    if isempty(temp)
       targetGrid = addEdge(targetGrid, p, p + 1);
    else
        if track(temp) == 0
            track(temp)=1;
            targetGrid = addEdge(targetGrid, p, p + 1);
        else
            track(temp) = track(temp)+1;
        end
    end
    temp = find(pointList == (p+a), 1);
    if isempty(temp)
       targetGrid = addEdge(targetGrid, p, p + a);
    else
        if track(temp) == 0
            track(temp)=1;
            targetGrid = addEdge(targetGrid, p, p + a);
        else
            track(temp)=track(temp)+1;
        end
    end
    if p-a > 0
        temp = find(pointList == (p-a),1);
        if isempty(temp)
           targetGrid = addEdge(targetGrid, p, p -a);
        else
            if track(temp) == 0
                track(temp)=1;
                targetGrid = addEdge(targetGrid, p, p -a);
            else
                track(temp)=track(temp)+1;
            end
        end
    end
    if p-1>0
        temp = find(pointList == (p-1),1);
        if isempty(temp)
           targetGrid = addEdge(targetGrid, p, p - 1);
        else
            if track(temp) == 0
                track(temp)=1;
                targetGrid = addEdge(targetGrid, p, p - 1);
            else
                track(temp)=track(temp)+1;
            end
        end
    end
end

end